package ca.digitalcave.drumslave.model.config;

import java.util.List;

import com.thoughtworks.xstream.annotations.XStreamAlias;
import com.thoughtworks.xstream.annotations.XStreamAsAttribute;
import com.thoughtworks.xstream.annotations.XStreamImplicit;

@XStreamAlias("option-mapping")
public class ConfigOptionMapping {

	@XStreamAsAttribute
	@XStreamAlias("pad-name")
	private String padName;
	@XStreamAsAttribute
	@XStreamAlias("zone-name")
	private String zoneName;
	@XStreamImplicit
	private List<ConfigOption> options;
	
	public String getPadName() {
		return padName;
	}
	public void setPadName(String padName) {
		this.padName = padName;
	}
	public String getZoneName() {
		return zoneName;
	}
	public void setZoneName(String zoneName) {
		this.zoneName = zoneName;
	}
	public List<ConfigOption> getOptions() {
		return options;
	}
	public void setOptions(List<ConfigOption> options) {
		this.options = options;
	}	
	
	@Override
	public String toString() {
		return padName + ":" + zoneName + ":" + options;
	}
}
